#!/usr/bin/wxlua
-- =========================================================================================

if not wx then require "wx" end; wxr = { }

-- =========================================================================================

wxr.vars = {
	version		= "0.06.020",
	copyright	= "(c) barabanus, 2008",

	fontface 	= "Arial",
	fontsize	= 4,
	bgcolor 	= "#000084",
	fgcolor 	= "#ffffff",

	width 		= 500,
	height 		= 500,
}
wxr.vars.title 	= "SixDays wxRunner v"..wxr.vars.version

-- =========================================================================================
-- =========================================================================================

wxr.ansi = {
	[0x0410] = "",	[0x0430] = "",	[0x0411] = "",	[0x0431] = "",
	[0x0412] = "",	[0x0432] = "",	[0x0413] = "",	[0x0433] = "",
	[0x0414] = "",	[0x0434] = "",	[0x0415] = "",	[0x0435] = "",
	[0x0401] = "",	[0x0451] = "",	[0x0416] = "",	[0x0436] = "",
	[0x0417] = "",	[0x0437] = "",	[0x0418] = "",	[0x0438] = "",
	[0x0419] = "",	[0x0439] = "",	[0x041A] = "",	[0x043A] = "",
	[0x041B] = "",	[0x043B] = "",	[0x041C] = "",	[0x043C] = "",
	[0x041D] = "",	[0x043D] = "",	[0x041E] = "",	[0x043E] = "",
	[0x041F] = "",	[0x043F] = "",	[0x0420] = "",	[0x0440] = "",
	[0x0421] = "",	[0x0441] = "",	[0x0422] = "",	[0x0442] = "",
	[0x0423] = "",	[0x0443] = "",	[0x0424] = "",	[0x0444] = "",
	[0x0425] = "",	[0x0445] = "",	[0x0426] = "",	[0x0446] = "",
	[0x0427] = "",	[0x0447] = "",	[0x0428] = "",	[0x0448] = "",
	[0x0429] = "",	[0x0449] = "",	[0x042A] = "",	[0x044A] = "",
	[0x042B] = "",	[0x044B] = "",	[0x042C] = "",	[0x044C] = "",
	[0x042D] = "",	[0x044D] = "",	[0x042E] = "",	[0x044E] = "",
	[0x042F] = "",	[0x044F] = "",	[0x0406] = "",	[0x0456] = "",
	[0x0407] = "",	[0x0457] = "",	[0x0490] = "",	[0x0491] = "",
	[0x0404] = "",	[0x0454] = "",
}

wxr.uni = { }; for k, v in pairs(wxr.ansi) do wxr.uni[v:byte()] = k end

-- =========================================================================================

function wxr:tohtml( text, plain )
	local html, byte = ""
	
	if plain then
		text = text:gsub("&", "&amp;"):gsub("<", "&lt;"):gsub(">", "&gt;")
		text = text:gsub("(%S) (%S)","%1&#32;%2"):gsub(" ", "&nbsp;")
	end
	
	for i = 1, #text do
		byte = text:byte(i)
		if byte < 0x80
			then html = html..text:sub(i, i)
			else html = html..("&#%d;"):format(wxr.uni[byte] or byte)
		end
	end
	
	return html
end

-- =========================================================================================

function wxr:toansi( text )
	local ansi, byte, word = ""
	local skip = false
	
	for i = 1, #text do
		if not skip then
			byte = text:byte(i)
			if byte == 208 or byte == 209 then
				if i ~= #text then
					word = math.mod(byte, 32) * 64 + math.mod(text:byte(i+1), 64)
					if wxr.ansi[word] then ansi = ansi..wxr.ansi[word] end
					skip = true
				end
			else
				ansi = ansi..text:sub(i, i)
			end
		else
			skip = false
		end
	end
	
	return ansi
end

-- =========================================================================================
-- =========================================================================================

function wxr : lift_eyelids()
	x:body [[
$(title)<br>
$(copyright)<br>
<br>
$(input)
<pre><table width=100% border=1><tr><td>$(output)</table></pre>
]]
	
	_G.print = function(...)
		for i, a in ipairs(arg) do arg[i] = tostring(a) end
		x:pln(table.concat(arg, "<td>"))
	end
	
	local std = "<i>".._VERSION.." console</i>"
	
	local fenv = setmetatable({ }, { __index = _G })
	
	x:on_input( function(text)
		x:clear()
		local f, e, r = loadstring(text)
		if not f then return x:p(e) end
		f, e = pcall(setfenv(f, fenv))
		if not f then return x:p(e) end
		if #wxr.vars.print == 0 then x:pln(std) end
		wxr.vars.print = wxr.vars.print:gsub("<br>$",""):gsub("<br>","<tr><td>")
	end)
	
	if wxr.script then
		local pre = "<b><font color=yellow>"
		local post = "</font></b> use no wxRunner<stop><clear>"
		local name = wxr.script
		for n in name:gmatch "[/\\]+([^/\\]-%.lua)$" do name = n end
		x:p(pre..name..post)
	end
	x:pln(std)
end

-- =========================================================================================
-- =========================================================================================

wxr.input = { it = 0, pre = "", post = "" }

-- =========================================================================================

function wxr.on_char_html( event )
	event:Skip(true)
	
	if event:GetKeyCode() == wx.WXK_CONTROL then return	end
	wxr.wnd.input:SetFocus()
	wxr.wnd.input:EmulateKeyPress( event )
end

-- =========================================================================================

wxr.onkey = {
	[wx.WXK_BACK] 	= function() return input.pre:sub(1,-2), input.post end,
	[wx.WXK_DELETE]	= function() return input.pre, input.post:sub(2) end,
	[wx.WXK_LEFT]	= function() return input.pre:sub(1,-2), input.pre:sub(-1,-1)..input.post end,
	[wx.WXK_RIGHT]	= function() return input.pre..input.post:sub(1,1), input.post:sub(2) end,
	[wx.WXK_HOME]	= function() return "", input.pre..input.post end,
	[wx.WXK_END]	= function() return input.pre..input.post, "" end,
	[wx.WXK_UP]		= function()
						wxr.input.it = math.min(wxr.input.it+1, #wxr.input+1)
						return wxr.input.it<=#wxr.input and wxr.input[wxr.input.it] or "", ""
					end,
	[wx.WXK_DOWN]	= function()
						wxr.input.it = math.max(wxr.input.it-1, 0)
						return wxr.input.it>0 and wxr.input[wxr.input.it] or "", ""
					end,
	[wx.WXK_ESCAPE]	= function() return "", "", wnd.main:Close() end,
}

function wxr.on_char_input( event )
	event:Skip(false)
	local code = event:GetKeyCode()
	
	if wxr.pending and code ~= wx.WXK_ESCAPE then
		wxr.vars.print, wxr.pending = wxr.vars.print..wxr.pending
		wxr:postprint()
		wxr:update()
		return
	end
	
	if (32 <= code and code < 127) or wxr.uni[code] then
		wxr.input.pre = wxr.input.pre..string.char(code)
		
	elseif wxr.onkey[code] then
		wxr.input.pre, wxr.input.post = wxr.onkey[code]()
		
	-- RETURN
	elseif code == wx.WXK_RETURN then
		local input = wxr.input.pre..wxr.input.post
		if #input==0 then return end
		if input ~= wxr.input[1] then table.insert(wxr.input, 1, input) end
		wxr.input.it = 0
		if wxr.on_input then wxr.on_input( input ) end
		wxr:postprint()
		wxr.input.pre, wxr.input.cur, wxr.input.post = "", "", ""
		
	-- CTRL-C
	elseif event:ControlDown() and code == 3 then
		local text = wxr.wnd.html:SelectionToText()
		wxr.wnd.input:SetValue(text)
		wxr.wnd.input:SetSelection(-1,-1)
		wxr.wnd.input:Cut()
		
	-- CTRL-V
	elseif event:ControlDown() and code == 22 then
		wxr.wnd.input:Paste()
		local text = wxr:toansi(wxr.wnd.input:GetValue())
		wxr.wnd.input:Clear()
		wxr.input.pre = wxr.input.pre..text
	end	
	
	wxr:update()
end

-- =========================================================================================

wxr.vars.anykey = "[<i>Press&nbsp;any&nbsp;key</i>]"

function wxr:update_input()
	if wxr.pending then
		vars.sym, vars.pre, vars.cur = "", "$(anykey)", ""
		return
	end
	
	vars.sym = "<td>&gt;<td width=2>"
	local pre = (#input.pre>0) and "<td>"..wxr:tohtml(input.pre, true) or ""
	if #input.post == 0 then
		if #pre>0 then pre = pre.."<td width=2>" end
		vars.pre, vars.cur, vars.post = pre, "&nbsp;&nbsp;", ""
	else
		local cur = input.post:sub(1,1)
		cur = (cur == " ") and "&nbsp;" or wxr:tohtml(cur, true)
		local post = input.post:sub(2)
		post = (#post>0) and "<td>"..wxr:tohtml(post, true) or ""
		vars.pre, vars.cur, vars.post = pre, cur, post
	end
end

-- =========================================================================================
-- =========================================================================================

wxr.tags = { open = { }, close = { }, }
wxr.vars.print, wxr.vars.cleared = "", ""

-- =========================================================================================

function wxr.tags : add( tag, value )
	self.open[tag] = value
	local close = ""
	for expr in value:gmatch "%b<>" do
		for tag in expr:gmatch "<%s*([%w_]+)" do
			close = ("</%s>%s"):format(tag, close)
		end
	end
	self.close[tag] = close
end

-- =========================================================================================

function wxr : postprint()
	local output, p1, p2 = vars.print
		
	p1, p2 = output:find "<%s*stop%s*>"
	if p1 and p2 then
		vars.print = output:sub(1, p1-1)
		wxr.pending = output:sub(p2+1)
		wxr:postprint()
		return
	end
	
	p1, p2 = output:find "<%s*clear%s*>"
	if p1 and p2 then
		vars.print = output:sub(p2+1)
		wxr:postprint()
		return
	end
	
	output = output:gsub("<br>","\n"):gsub("(%s+)$",""):gsub("\n","<br>")	
	vars.output = output
end

-- =========================================================================================

function wxr : print( text )
	text = tostring(text):gsub("\n","<br>")
	vars.print = vars.print..text
	wxr.blind = false
end

-- =========================================================================================

function wxr : clear() vars.print, vars.cleared = "", vars.print end
function wxr : restore() vars.print = vars.cleared end

-- =========================================================================================
-- =========================================================================================

x = { }

-- =========================================================================================

function x:border(w) wxr.wnd.html:SetBorders(w) end
function x:pln(text) wxr:print(text.."\n") end
function x:p(text) wxr:print(text) end
function x:restore() wxr:restore() end
function x:clear() wxr:clear() end
x.print, x.println = x.p, x.pln

function x:on_input(f)
	assert(type(f)=="function", "on_input handler must be function( text )")
	wxr.on_input = f
end

-- =========================================================================================

local x_tags = { }
setmetatable(x_tags, {
	__newindex = function(t,k,v)
		assert(type(k)=="string" and type(v)=="string", "key and value must be strings")
		wxr.tags:add(k, v)
	end
})

-- =========================================================================================

local x_index = { tags = x_tags, }
setmetatable(x, {
	__index = function(t,k)
		if x_index[k] then return x_index[k] end
		return function(self, text) wxr.vars[k] = text; wxr.blind = false end
	end,
	__newindex = function(t,k,v)
		assert(false, "wxRunner's interface is read-only")
	end,
})

-- =========================================================================================
-- =========================================================================================

wxr.vars.html = [[
<html>
	<head>
		<title>$(title) $(copyright)</title>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-16">
	</head>
	
	<body bgcolor=$(bgcolor) text=$(fgcolor)>
		<font size=$(fontsize) face="$(fontface)">
			$(body)
		</font>
	</body>
</html>]]

wxr.vars.input = ([[
<table cellspacing=0 cellpadding=0>
	<tr>$(sym)
	$(pre)
	<td bgcolor=$(fgcolor)><font color=$(bgcolor)>$(cur)</font>
	$(post)
</table>]]):gsub("[\t\n]","")

wxr.vars.body = [[
$(output)
$(input)
]]

-- =========================================================================================

wxr.wnd = {	main, html, input = nil, nil, nil }

-- =========================================================================================

function wxr.on_idle( event )
	event:Skip( false )
	
	if wxr.need_update then
		wxr.need_update = false
		wxr:do_update()
	end
end

-- =========================================================================================

wxr.tags:add( "wxrerror", "<table><tr><td bgcolor=red><font color=white>" )

local wxr_vars_env = setmetatable({ }, {
	__index = function(t,k)
		return wxr.vars[k] or _G[k] or ""
	end,
})

local wxr_gsub_vars = function( expr )
	local f, e, r = loadstring("return "..expr:sub(2,-2))
	if not f then return "<wxrerror>"..e.."</wxrerror>" end
	f, e = pcall(setfenv(f, wxr_vars_env))
	if not f then return "<wxrerror>"..e.."</wxrerror>" end
	return e and wxr:tohtml(tostring(e)) or ""
end

local wxr_gsub_tags = function( expr )
	for flag, tag in expr:gmatch "<%s*([/]*)%s*([%w_]+)" do
		local page = (#flag==0) and "open" or "close"
		if wxr.tags[page][tag] then return wxr.tags[page][tag] end
	end
	return expr
end

function wxr : do_update()
	wxr:update_input()
	
	local html, ctr, num = vars.html, 10
	repeat 
		ctr = ctr-1
		html, num = html:gsub("%b<>", wxr_gsub_tags):gsub("%$(%b())", wxr_gsub_vars)
	until ctr==0 or num == 0
	
	wnd.html:Freeze()
	wnd.html:SetPage(html)
	wnd.html:Thaw()
end

function wxr : update()	wxr.need_update = true end

-- =========================================================================================

function wxr : start()
	wnd.main = wx.wxFrame( wx.NULL, wx.wxID_ANY, vars.title, wx.wxDefaultPosition, 
		wx.wxSize(vars.width, vars.height), wx.wxMINIMIZE_BOX + wx.wxSYSTEM_MENU 
		+ wx.wxCAPTION + wx.wxCLOSE_BOX + wx.wxCLIP_CHILDREN )
	wnd.main:Connect( wx.wxEVT_IDLE, wxr.on_idle )
	
	wnd.html = wx.wxLuaHtmlWindow( wnd.main )
	wnd.html:Connect( wx.wxID_ANY, wx.wxEVT_KEY_DOWN, wxr.on_char_html )
	do_update()
	
	wnd.main:Show( true )
	
	wnd.input = wx.wxTextCtrl( wnd.main, wx.wxID_ANY, "", wx.wxPoint(10000,10000) )
	wnd.input:Connect( wx.wxID_ANY, wx.wxEVT_CHAR, wxr.on_char_input )
	wnd.input:SetFocus()
	
	wx.wxGetApp():MainLoop()
end

-- =========================================================================================

wxr.fenv = setmetatable({ }, {
	__index = function( t,k )
		local v = wxr[k]
		return (v ~= nil) and v or _G[k]
	end
})

local wxr_setfenv = function(table)
	for k, v in pairs(table) do
		if type(v) == "function" then setfenv(v, wxr.fenv) end
	end
end

wxr_setfenv(wxr)
wxr_setfenv(wxr.onkey)

-- =========================================================================================

wxr.blind = true
if arg[1] then 
	wxr.script = arg[1]
	dofile(arg[1])
else
	local dialog = wx.wxFileDialog( wx.NULL, "Open a script",
		"", "", "Lua files (*.lua)|*.lua",
		wx.wxOPEN + wx.wxFILE_MUST_EXIST )
	if dialog:ShowModal() == wx.wxID_OK then
		wxr.script = wxr:toansi(dialog:GetPath())
		dofile(wxr.script)
	end
	dialog:Destroy()
end

if wxr.blind then wxr:lift_eyelids() end

-- =========================================================================================

wxr:postprint()
wxr:start()

-- =========================================================================================